--- old/usr/src/Makefile.master	2014-04-11 13:24:01.317074245 +0100
+++ new/usr/src/Makefile.master	2014-04-11 13:24:01.325436239 +0100
@@ -22,6 +22,7 @@
 #
 # Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright (c) 2012 by Delphix. All rights reserved.
+# Copyright (c) 2014 Andrew Stormont.
 #
 
 #
@@ -246,8 +247,7 @@
 # architectures on which we do not build 64-bit versions.
 # (There are no such architectures at the moment.)
 #
-# Set BUILD64=# in the environment to disable 64-bit amd64
-# builds on i386 machines.
+# Set BUILD64=# in the environment to disable 64-bit builds.
 
 MACH64_1=	$(MACH:sparc=sparcv9)
 MACH64=		$(MACH64_1:i386=amd64)
@@ -255,9 +255,13 @@
 MACH32_1=	$(MACH:sparc=sparcv7)
 MACH32=		$(MACH32_1:i386=i86)
 
-sparc_BUILD64=
-i386_BUILD64=
-BUILD64=	$($(MACH)_BUILD64)
+BUILD64=
+sparc_BUILD64=	$(POUND_SIGN)
+i386_BUILD64=	$(POUND_SIGN)
+$($(MACH)_BUILD64)=	$(BUILD64)
+
+NOT_BUILD64=
+$(BUILD64)NOT_BUILD64=	$(POUND_SIGN)
 
 #
 # C compiler mode. Future compilers may change the default on us,
--- old/usr/src/Makefile.master.64	2014-04-11 13:24:01.550509585 +0100
+++ new/usr/src/Makefile.master.64	2014-04-11 13:24:01.557979177 +0100
@@ -20,6 +20,7 @@
 #
 #
 # Copyright (c) 1997, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 # rebind basic build macros to 64-bit versions
@@ -37,6 +38,15 @@
 LINK.cc=	$(LINK64.cc)
 LINT.c=		$(LINT64.c)
 
+$(NOT_BUILD64)COMPILE.c=	/usr/bin/false
+$(NOT_BUILD64)COMPILE.cc=	/usr/bin/false
+$(NOT_BUILD64)COMPILE.s=	/usr/bin/false
+$(NOT_BUILD64)COMPILE.d=	/usr/bin/false
+$(NOT_BUILD64)COMPILE.b=	/usr/bin/false
+$(NOT_BUILD64)LINK.c=		/usr/bin/false
+$(NOT_BUILD64)LINK.cc=		/usr/bin/false
+$(NOT_BUILD64)LINT.c=		/usr/bin/false
+
 CTF_FLAGS=	$(CTF_FLAGS_64)
 
 OFFSETS_CREATE=	$(OFFSETS_CREATE64)
@@ -72,6 +82,13 @@
 LD=		$($(MACH64)_LD)
 LINT=		$($(MACH64)_LINT)
 
+$(NOT_BUILD64)CC=	/usr/bin/false
+$(NOT_BUILD64)CCC=	/usr/bin/false
+$(NOT_BUILD64)CPP=	/usr/bin/false
+$(NOT_BUILD64)AS=	/usr/bin/false
+$(NOT_BUILD64)LD=	/usr/bin/false
+$(NOT_BUILD64)LINT=	/usr/bin/false
+
 REAL_CC=	$(CW_CC_CMD:sh)
 REAL_CCC=	$(CW_CCC_CMD:sh)
 
--- old/usr/src/cmd/sgs/elfedit/modules/Makefile	2014-04-11 13:24:01.755791648 +0100
+++ new/usr/src/cmd/sgs/elfedit/modules/Makefile	2014-04-11 13:24:01.764393666 +0100
@@ -19,16 +19,16 @@
 # CDDL HEADER END
 #
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 # Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		$(SRC)/Makefile.master
 
 
 SUBDIRS=	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all:=		TARGET=	all
 chkmsg:=	TARGET=	chkmsg
@@ -46,9 +46,6 @@
 
 $(SUBDIRS):	FRC
 		@cd $@; pwd; $(MAKE) $(TARGET)
-		@if [ -d $(MACH64) ]; then                      \
-			cd $(MACH64); pwd; $(MAKE) $(TARGET);   \
-		else /bin/true; fi
 
 
 FRC:
--- old/usr/src/cmd/sgs/link_audit/Makefile	2014-04-11 13:24:01.974565129 +0100
+++ new/usr/src/cmd/sgs/link_audit/Makefile	2014-04-11 13:24:01.982815881 +0100
@@ -20,6 +20,7 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../../../Makefile.master
@@ -61,6 +62,7 @@
 
 
 SUBDIRS=	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all:=		TARGET=	all
 install:=	TARGET=	install
@@ -81,9 +83,6 @@
 
 $(SUBDIRS):	FRC
 		@cd $@; pwd; $(MAKE) $(TARGET)
-		@if [ -d $(MACH64) ]; then                      \
-			cd $(MACH64); pwd; $(MAKE) $(TARGET);   \
-		else /bin/true; fi
 
 $(ROOTDEMODIRS):
 	$(INS.dir)
--- old/usr/src/cmd/strings/Makefile	2014-04-11 13:24:02.178108749 +0100
+++ new/usr/src/cmd/strings/Makefile	2014-04-11 13:24:02.186414113 +0100
@@ -19,18 +19,18 @@
 # CDDL HEADER END
 #
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
-#
 # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 # cmd/strings/Makefile
 
-PROG:sh=	basename `pwd`
+PROG = strings
 
 include ../Makefile.cmd
 
-SUBDIRS	= 	$(MACH) $(MACH64)
+SUBDIRS	= 	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all	:=	TARGET = all
 install	:=	TARGET = install
--- old/usr/src/lib/cfgadm_plugins/sata/Makefile	2014-04-11 13:24:02.375319326 +0100
+++ new/usr/src/lib/cfgadm_plugins/sata/Makefile	2014-04-11 13:24:02.384840944 +0100
@@ -21,12 +21,14 @@
 #
 # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 #
 
 include		../../Makefile.lib
 
-$(INTEL_BLD)SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+$(INTEL_BLD)SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/libaio/Makefile	2014-04-11 13:24:02.574348034 +0100
+++ new/usr/src/lib/libaio/Makefile	2014-04-11 13:24:02.583312206 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/libc/Makefile	2014-04-11 13:24:02.770245235 +0100
+++ new/usr/src/lib/libc/Makefile	2014-04-11 13:24:02.779024768 +0100
@@ -24,6 +24,8 @@
 # Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
+# Copyright 2014 Andrew Stormont.
+#
 
 LIBBASENAME=	libc
 LIBRARY=	$(LIBBASENAME:%=%.a)
@@ -129,7 +131,7 @@
 
 .KEEP_STATE:
 
-all:	all_h lib32 $(BUILD64) .WAIT lib64 .WAIT etc THIRDPARTYLICENSE
+all:	all_h lib .WAIT etc THIRDPARTYLICENSE
 
 THIRDPARTYLICENSE: extract-copyright
 	$(RM) $@
@@ -151,6 +153,8 @@
 		exit 1; \
 	fi
 
+lib: lib32 $(BUILD64) .WAIT lib64
+
 $(MACH)/assym.h $(MACH64)/assym.h:
 	@cd $(@D); $(MAKE) assym.h
 
@@ -166,10 +170,7 @@
 $($(MACH)_COMP): FRC
 	@cd $(@); pwd; $(MAKE) $(TARGET)
 
-install:	all			\
-		etc			\
-		inslib32		\
-		$(BUILD64) inslib64
+install:	all etc inslib
 
 inslib32:	$(ROOTFS_LIBS) $(ROOTFS_LINKS) $(ROOTFS_LINT) \
 		$(ROOTFS_LINTLIB) \
@@ -179,9 +180,11 @@
 		$(ROOTFS_LINTLIB64) \
 		$(ROOTVARIANTLIBS64)
 
+inslib: inslib32 $(BUILD64) inslib64
+
 install_h: all_h $(ROOTHDRS)
 
-all_h:	$(MACH)/assym.h $(MACH64)/assym.h
+all_h:	$(MACH)/assym.h $(BUILD64) $(MACH64)/assym.h
 
 check:	$(CHECKHDRS)
 
--- old/usr/src/lib/libdoor/Makefile	2014-04-11 13:24:02.966948210 +0100
+++ new/usr/src/lib/libdoor/Makefile	2014-04-11 13:24:02.975125200 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/libintl/Makefile	2014-04-11 13:24:03.157446901 +0100
+++ new/usr/src/lib/libintl/Makefile	2014-04-11 13:24:03.165035171 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/libkrb5/Makefile	2014-04-11 13:24:03.348631743 +0100
+++ new/usr/src/lib/libkrb5/Makefile	2014-04-11 13:24:03.357561503 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 INSTALLED_HDRS = \
 		com_err.h krb5.h
--- old/usr/src/lib/libmd/Makefile	2014-04-11 13:24:03.541390924 +0100
+++ new/usr/src/lib/libmd/Makefile	2014-04-11 13:24:03.549738764 +0100
@@ -21,13 +21,15 @@
 
 #
 # Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		$(SRC)/lib/Makefile.lib
 
 $(SPARC_BLD)CAPDIR = capabilities
 
-SUBDIRS=	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS=	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 HDRS =		md4.h md5.h sha1.h sha2.h
 HDRDIR =	common
--- old/usr/src/lib/libmd5/Makefile	2014-04-11 13:24:03.776692400 +0100
+++ new/usr/src/lib/libmd5/Makefile	2014-04-11 13:24:03.788081507 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/libpthread/Makefile	2014-04-11 13:24:03.974950675 +0100
+++ new/usr/src/lib/libpthread/Makefile	2014-04-11 13:24:03.983419466 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/librt/Makefile	2014-04-11 13:24:04.162814457 +0100
+++ new/usr/src/lib/librt/Makefile	2014-04-11 13:24:04.172026845 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/libsched/Makefile	2014-04-11 13:24:04.355457731 +0100
+++ new/usr/src/lib/libsched/Makefile	2014-04-11 13:24:04.364336896 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/libthread/Makefile	2014-04-11 13:24:04.547710868 +0100
+++ new/usr/src/lib/libthread/Makefile	2014-04-11 13:24:04.557307066 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/libw/Makefile	2014-04-11 13:24:04.742862606 +0100
+++ new/usr/src/lib/libw/Makefile	2014-04-11 13:24:04.751213183 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/libxnet/Makefile	2014-04-11 13:24:04.930804260 +0100
+++ new/usr/src/lib/libxnet/Makefile	2014-04-11 13:24:04.939162900 +0100
@@ -21,11 +21,13 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		../Makefile.lib
 
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/lib/pkcs11/libsoftcrypto/Makefile	2014-04-11 13:24:05.126221990 +0100
+++ new/usr/src/lib/pkcs11/libsoftcrypto/Makefile	2014-04-11 13:24:05.134465787 +0100
@@ -21,12 +21,15 @@
 
 #
 # Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		$(SRC)/lib/Makefile.lib
 
 CAPDIR =	capabilities
-SUBDIRS =	$(MACH) $(BUILD64) $(MACH64) $(PLATFORMS)
+SUBDIRS =	$(MACH)
+$(BUILD64)SUBDIRS += $(MACH64)
+SUBDIRS +=	$(PLATFORMS)
 
 all :=		TARGET= all
 clean :=	TARGET= clean
--- old/usr/src/pkg/Makefile	2014-04-11 13:24:05.316362315 +0100
+++ new/usr/src/pkg/Makefile	2014-04-11 13:24:05.324495134 +0100
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 include $(SRC)/Makefile.master
@@ -169,9 +170,13 @@
 	i386_ONLY=$(POUND_SIGN) \
 	sparc_ONLY=$(POUND_SIGN) \
 	$(PKGMACH)_ONLY= \
+	i386_BUILD64=$(POUND_SIGN) \
+	sparc_BUILD64=$(POUND_SIGN) \
+	$(PKGMACH)_BUILD64= \
 	ARCH=$(PKGMACH) \
 	ARCH32=$($(PKGMACH)_ARCH32) \
 	ARCH64=$($(PKGMACH)_ARCH64) \
+	BUILD64=$(BUILD64) \
 	PKGVERS_COMPONENT=$(PKGVERS_COMPONENT) \
 	PKGVERS_BUILTON=$(PKGVERS_BUILTON) \
 	PKGVERS_BRANCH=$(PKGVERS_BRANCH) \
--- old/usr/src/pkg/manifests/SUNWcs.mf	2014-04-11 13:24:05.531072254 +0100
+++ new/usr/src/pkg/manifests/SUNWcs.mf	2014-04-11 13:24:05.540209108 +0100
@@ -23,6 +23,7 @@
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2012 Nexenta Systems, Inc. All rights reserved.
 # Copyright (c) 2013 Gary Mills
+# Copyright 2014 Andrew Stormont.
 #
 
 <include SUNWcs.man1.inc>
@@ -135,7 +136,7 @@
 dir path=usr group=sys
 dir path=usr/bin
 dir path=usr/bin/$(ARCH32)
-dir path=usr/bin/$(ARCH64)
+$(BUILD64)dir path=usr/bin/$(ARCH64)
 dir path=usr/ccs
 dir path=usr/ccs/bin
 dir path=usr/demo
@@ -162,7 +163,7 @@
 dir path=usr/kernel/sys/$(ARCH64) group=sys
 dir path=usr/kvm
 dir path=usr/lib
-dir path=usr/lib/$(ARCH64)
+$(BUILD64)dir path=usr/lib/$(ARCH64)
 dir path=usr/lib/audit
 dir path=usr/lib/class
 dir path=usr/lib/class/FX
@@ -175,7 +176,7 @@
 dir path=usr/lib/devfsadm/linkmod group=sys
 dir path=usr/lib/fs group=sys
 dir path=usr/lib/fs/autofs group=sys
-dir path=usr/lib/fs/autofs/$(ARCH64) group=sys
+$(BUILD64)dir path=usr/lib/fs/autofs/$(ARCH64) group=sys
 dir path=usr/lib/fs/cachefs group=sys
 dir path=usr/lib/fs/ctfs group=sys
 dir path=usr/lib/fs/dev group=sys
@@ -184,7 +185,7 @@
 dir path=usr/lib/fs/lofs group=sys
 dir path=usr/lib/fs/mntfs group=sys
 dir path=usr/lib/fs/nfs group=sys
-dir path=usr/lib/fs/nfs/$(ARCH64) group=sys
+$(BUILD64)dir path=usr/lib/fs/nfs/$(ARCH64) group=sys
 dir path=usr/lib/fs/objfs group=sys
 dir path=usr/lib/fs/proc group=sys
 dir path=usr/lib/fs/sharefs group=sys
@@ -200,7 +201,7 @@
 dir path=usr/lib/iconv
 dir path=usr/lib/inet
 dir path=usr/lib/inet/$(ARCH32)
-dir path=usr/lib/inet/$(ARCH64)
+$(BUILD64)dir path=usr/lib/inet/$(ARCH64)
 dir path=usr/lib/inet/dhcp
 dir path=usr/lib/inet/dhcp/nsu
 dir path=usr/lib/inet/dhcp/svc
@@ -220,7 +221,7 @@
 dir path=usr/lib/reparse
 dir path=usr/lib/saf
 dir path=usr/lib/secure
-dir path=usr/lib/secure/$(ARCH64)
+$(BUILD64)dir path=usr/lib/secure/$(ARCH64)
 dir path=usr/lib/security
 dir path=usr/lib/sysevent
 dir path=usr/lib/sysevent/modules
@@ -235,7 +236,7 @@
 dir path=usr/sadm/install/scripts
 dir path=usr/sbin
 $(i386_ONLY)dir path=usr/sbin/$(ARCH32)
-dir path=usr/sbin/$(ARCH64)
+$(BUILD64)dir path=usr/sbin/$(ARCH64)
 dir path=usr/share
 dir path=usr/share/doc group=other
 dir path=usr/share/doc/ksh
@@ -268,7 +269,7 @@
 dir path=var/idmap group=daemon owner=daemon
 dir path=var/inet group=sys
 dir path=var/ld
-dir path=var/ld/$(ARCH64)
+$(BUILD64)dir path=var/ld/$(ARCH64)
 dir path=var/log group=sys
 dir path=var/logadm
 dir path=var/mail group=mail mode=1777
@@ -681,21 +682,21 @@
 file path=usr/bin/$(ARCH32)/savecore mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/setuname mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/uptime mode=4555
-file path=usr/bin/$(ARCH64)/amt mode=0555
-file path=usr/bin/$(ARCH64)/crle mode=0555
-file path=usr/bin/$(ARCH64)/decrypt mode=0555
-file path=usr/bin/$(ARCH64)/digest mode=0555
-file path=usr/bin/$(ARCH64)/ksh93 mode=0555
-file path=usr/bin/$(ARCH64)/ls mode=0555
-file path=usr/bin/$(ARCH64)/moe mode=0555
-file path=usr/bin/$(ARCH64)/newtask group=sys mode=4555
-file path=usr/bin/$(ARCH64)/nohup mode=0555
-file path=usr/bin/$(ARCH64)/prctl mode=0555
-file path=usr/bin/$(ARCH64)/prstat mode=0555
-file path=usr/bin/$(ARCH64)/ps mode=0555
-file path=usr/bin/$(ARCH64)/savecore mode=0555
-file path=usr/bin/$(ARCH64)/setuname mode=0555
-file path=usr/bin/$(ARCH64)/uptime mode=4555
+$(BUILD64)file path=usr/bin/$(ARCH64)/amt mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/crle mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/decrypt mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/digest mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/ksh93 mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/ls mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/moe mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/newtask group=sys mode=4555
+$(BUILD64)file path=usr/bin/$(ARCH64)/nohup mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/prctl mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/prstat mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/ps mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/savecore mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/setuname mode=0555
+$(BUILD64)file path=usr/bin/$(ARCH64)/uptime mode=4555
 $(i386_ONLY)file path=usr/bin/addbadsec mode=0555
 file path=usr/bin/alias mode=0555
 file path=usr/bin/amt mode=0555
@@ -922,7 +923,7 @@
 $(i386_ONLY)file path=usr/kernel/sys/exacctsys group=sys mode=0755
 $(i386_ONLY)file path=usr/kernel/sys/sysacct group=sys mode=0755
 file path=usr/kvm/README group=sys
-file path=usr/lib/$(ARCH64)/libshare.so.1
+$(BUILD64)file path=usr/lib/$(ARCH64)/libshare.so.1
 file path=usr/lib/audit/audit_record_attr mode=0444
 file path=usr/lib/calprog mode=0555
 file path=usr/lib/class/FX/FXdispadmin mode=0555
@@ -1216,7 +1217,7 @@
 file path=usr/lib/iconv/iconv_data mode=0444
 file path=usr/lib/idmapd mode=0555
 file path=usr/lib/inet/$(ARCH32)/in.iked mode=0555
-file path=usr/lib/inet/$(ARCH64)/in.iked mode=0555
+$(BUILD64)file path=usr/lib/inet/$(ARCH64)/in.iked mode=0555
 file path=usr/lib/inet/certdb mode=0555
 file path=usr/lib/inet/certlocal mode=0555
 file path=usr/lib/inet/certrldb mode=0555
@@ -1291,18 +1292,18 @@
 $(i386_ONLY)file path=usr/sbin/$(ARCH32)/sysdef group=sys mode=2555
 $(i386_ONLY)file path=usr/sbin/$(ARCH32)/update_drv group=sys mode=0555
 $(i386_ONLY)file path=usr/sbin/$(ARCH32)/whodo mode=4555
-file path=usr/sbin/$(ARCH64)/add_drv group=sys mode=0555
-file path=usr/sbin/$(ARCH64)/modinfo group=sys mode=0555
-file path=usr/sbin/$(ARCH64)/modload group=sys mode=0555
-file path=usr/sbin/$(ARCH64)/modunload group=sys mode=0555
-file path=usr/sbin/$(ARCH64)/pbind group=sys mode=0555
-file path=usr/sbin/$(ARCH64)/prtconf group=sys mode=2555
-file path=usr/sbin/$(ARCH64)/psrset group=sys mode=0555
-file path=usr/sbin/$(ARCH64)/rem_drv group=sys mode=0555
-file path=usr/sbin/$(ARCH64)/swap group=sys mode=2555
-file path=usr/sbin/$(ARCH64)/sysdef group=sys mode=2555
-file path=usr/sbin/$(ARCH64)/update_drv group=sys mode=0555
-file path=usr/sbin/$(ARCH64)/whodo mode=4555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/add_drv group=sys mode=0555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/modinfo group=sys mode=0555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/modload group=sys mode=0555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/modunload group=sys mode=0555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/pbind group=sys mode=0555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/prtconf group=sys mode=2555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/psrset group=sys mode=0555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/rem_drv group=sys mode=0555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/swap group=sys mode=2555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/sysdef group=sys mode=2555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/update_drv group=sys mode=0555
+$(BUILD64)file path=usr/sbin/$(ARCH64)/whodo mode=4555
 file path=usr/sbin/6to4relay mode=0555
 file path=usr/sbin/acctadm mode=0555
 file path=usr/sbin/allocate mode=4555
@@ -1495,12 +1496,12 @@
 hardlink path=usr/bin/$(ARCH32)/rksh target=ksh93
 hardlink path=usr/bin/$(ARCH32)/rksh93 target=ksh93
 $(i386_ONLY)hardlink path=usr/bin/$(ARCH32)/w target=uptime
-hardlink path=usr/bin/$(ARCH64)/encrypt target=decrypt
-hardlink path=usr/bin/$(ARCH64)/ksh target=ksh93
-hardlink path=usr/bin/$(ARCH64)/mac target=digest
-hardlink path=usr/bin/$(ARCH64)/rksh target=ksh93
-hardlink path=usr/bin/$(ARCH64)/rksh93 target=ksh93
-hardlink path=usr/bin/$(ARCH64)/w target=uptime
+$(BUILD64)hardlink path=usr/bin/$(ARCH64)/encrypt target=decrypt
+$(BUILD64)hardlink path=usr/bin/$(ARCH64)/ksh target=ksh93
+$(BUILD64)hardlink path=usr/bin/$(ARCH64)/mac target=digest
+$(BUILD64)hardlink path=usr/bin/$(ARCH64)/rksh target=ksh93
+$(BUILD64)hardlink path=usr/bin/$(ARCH64)/rksh93 target=ksh93
+$(BUILD64)hardlink path=usr/bin/$(ARCH64)/w target=uptime
 hardlink path=usr/bin/bg target=../../usr/bin/alias
 hardlink path=usr/bin/cd target=../../usr/bin/alias
 hardlink path=usr/bin/cksum target=../../usr/bin/alias
@@ -1805,7 +1806,8 @@
 link path=usr/ccs/bin/m4 target=../../bin/m4
 link path=usr/has/bin/jsh target=sh
 link path=usr/has/lib/rsh target=../bin/sh
-link path=usr/lib/$(ARCH64)/ld.so.1 target=../../../lib/$(ARCH64)/ld.so.1
+$(BUILD64)link path=usr/lib/$(ARCH64)/ld.so.1 \
+    target=../../../lib/$(ARCH64)/ld.so.1
 link path=usr/lib/cron target=../../etc/cron.d
 link path=usr/lib/devfsadm/devfsadmd target=../../sbin/devfsadm
 link path=usr/lib/embedded_su target=../bin/su
@@ -1817,7 +1819,7 @@
 link path=usr/lib/locale/POSIX target=./C
 link path=usr/lib/rsh target=../bin/ksh93
 link path=usr/lib/secure/32 target=.
-link path=usr/lib/secure/64 target=$(ARCH64)
+$(BUILD64)link path=usr/lib/secure/64 target=$(ARCH64)
 link path=usr/lib/wusbd target=../../sbin/wusbadm
 link path=usr/mail target=../var/mail
 link path=usr/net/nls/listen target=../../lib/saf/listen
@@ -1876,7 +1878,7 @@
 link path=usr/src target=./share/src
 link path=usr/tmp target=../var/tmp
 link path=var/ld/32 target=.
-link path=var/ld/64 target=$(ARCH64)
+$(BUILD64)link path=var/ld/64 target=$(ARCH64)
 #
 # The bootadm binary needs the etc/release file.
 #
--- old/usr/src/pkg/manifests/benchmark-filebench.mf	2014-04-11 13:24:05.772820831 +0100
+++ new/usr/src/pkg/manifests/benchmark-filebench.mf	2014-04-11 13:24:05.781170441 +0100
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 set name=pkg.fmri value=pkg:/benchmark/filebench@$(PKGVERS)
@@ -35,14 +36,15 @@
 dir path=usr/benchmarks/filebench
 dir path=usr/benchmarks/filebench/bin
 $(i386_ONLY)dir path=usr/benchmarks/filebench/bin/$(ARCH)
-dir path=usr/benchmarks/filebench/bin/$(ARCH64)
+$(BUILD64)dir path=usr/benchmarks/filebench/bin/$(ARCH64)
 dir path=usr/benchmarks/filebench/config
 dir path=usr/benchmarks/filebench/scripts
 dir path=usr/benchmarks/filebench/workloads
 dir path=usr/share/man/man1
 $(i386_ONLY)file path=usr/benchmarks/filebench/bin/$(ARCH)/go_filebench \
     mode=0555
-file path=usr/benchmarks/filebench/bin/$(ARCH64)/go_filebench mode=0555
+$(BUILD64)file path=usr/benchmarks/filebench/bin/$(ARCH64)/go_filebench \
+    mode=0555
 file path=usr/benchmarks/filebench/bin/filebench mode=0555
 file path=usr/benchmarks/filebench/config/fileio.prof mode=0444
 file path=usr/benchmarks/filebench/config/filemacro.prof mode=0444
--- old/usr/src/pkg/manifests/compatibility-ucb.mf	2014-04-11 13:24:05.969245864 +0100
+++ new/usr/src/pkg/manifests/compatibility-ucb.mf	2014-04-11 13:24:05.976136285 +0100
@@ -22,6 +22,7 @@
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 set name=pkg.fmri value=pkg:/compatibility/ucb@$(PKGVERS)
@@ -39,9 +40,9 @@
 dir path=usr/share/man/man1b
 dir path=usr/ucb
 $(i386_ONLY)dir path=usr/ucb/$(ARCH32)
-dir path=usr/ucb/$(ARCH64)
+$(BUILD64)dir path=usr/ucb/$(ARCH64)
 dir path=usr/ucblib
-dir path=usr/ucblib/$(ARCH64)
+$(BUILD64)dir path=usr/ucblib/$(ARCH64)
 file path=etc/mail/Mail.rc original_name=SUNWscp:etc/mail/Mail.rc \
     preserve=true
 file path=usr/share/man/man1b/basename.1b
@@ -109,18 +110,18 @@
 file path=usr/ucb/vipw mode=0555
 file path=usr/ucb/whereis mode=0755
 file path=usr/ucb/whoami mode=0755
-file path=usr/ucblib/$(ARCH64)/libcurses.so.1
-file path=usr/ucblib/$(ARCH64)/libdbm.so.1
-file path=usr/ucblib/$(ARCH64)/librpcsoc.so.1
-file path=usr/ucblib/$(ARCH64)/libtermcap.so.1
-file path=usr/ucblib/$(ARCH64)/libucb.so.1
+$(BUILD64)file path=usr/ucblib/$(ARCH64)/libcurses.so.1
+$(BUILD64)file path=usr/ucblib/$(ARCH64)/libdbm.so.1
+$(BUILD64)file path=usr/ucblib/$(ARCH64)/librpcsoc.so.1
+$(BUILD64)file path=usr/ucblib/$(ARCH64)/libtermcap.so.1
+$(BUILD64)file path=usr/ucblib/$(ARCH64)/libucb.so.1
 file path=usr/ucblib/libcurses.so.1
 file path=usr/ucblib/libdbm.so.1
 file path=usr/ucblib/librpcsoc.so.1
 file path=usr/ucblib/libtermcap.so.1
 file path=usr/ucblib/libucb.so.1
 $(i386_ONLY)hardlink path=usr/ucb/$(ARCH32)/ps target=../../bin/$(ARCH32)/ps
-hardlink path=usr/ucb/$(ARCH64)/ps target=../../bin/$(ARCH64)/ps
+$(BUILD64)hardlink path=usr/ucb/$(ARCH64)/ps target=../../bin/$(ARCH64)/ps
 hardlink path=usr/ucb/ps target=../../usr/lib/isaexec
 legacy pkg=SUNWscpr \
     desc="utilities for user interface and source build compatibility with SunOS 4.x" \
@@ -217,13 +218,14 @@
 link path=usr/ucb/wc target=../bin/wc
 link path=usr/ucb/whois target=../bin/whois
 link path=usr/ucb/xstr target=../bin/xstr
-link path=usr/ucblib/$(ARCH64)/libcurses.so target=./libcurses.so.1
-link path=usr/ucblib/$(ARCH64)/libdbm.so target=./libdbm.so.1
-link path=usr/ucblib/$(ARCH64)/librpcsoc.so target=./librpcsoc.so.1
-link path=usr/ucblib/$(ARCH64)/libtermcap.so target=./libtermcap.so.1
-link path=usr/ucblib/$(ARCH64)/libucb.so target=./libucb.so.1
+$(BUILD64)link path=usr/ucblib/$(ARCH64)/libcurses.so target=./libcurses.so.1
+$(BUILD64)link path=usr/ucblib/$(ARCH64)/libdbm.so target=./libdbm.so.1
+$(BUILD64)link path=usr/ucblib/$(ARCH64)/librpcsoc.so target=./librpcsoc.so.1
+$(BUILD64)link path=usr/ucblib/$(ARCH64)/libtermcap.so \
+    target=./libtermcap.so.1
+$(BUILD64)link path=usr/ucblib/$(ARCH64)/libucb.so target=./libucb.so.1
 link path=usr/ucblib/32 target=.
-link path=usr/ucblib/64 target=$(ARCH64)
+$(BUILD64)link path=usr/ucblib/64 target=$(ARCH64)
 link path=usr/ucblib/libcurses.so target=./libcurses.so.1
 link path=usr/ucblib/libdbm.so target=./libdbm.so.1
 link path=usr/ucblib/librpcsoc.so target=./librpcsoc.so.1
--- old/usr/src/pkg/manifests/developer-apptrace.mf	2014-04-11 13:24:06.169869315 +0100
+++ new/usr/src/pkg/manifests/developer-apptrace.mf	2014-04-11 13:24:06.178100635 +0100
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 set name=pkg.fmri value=pkg:/developer/apptrace@$(PKGVERS)
@@ -34,11 +35,11 @@
 dir path=usr/bin
 dir path=usr/lib
 dir path=usr/lib/abi
-dir path=usr/lib/abi/$(ARCH64)
+$(BUILD64)dir path=usr/lib/abi/$(ARCH64)
 dir path=usr/share/man
 dir path=usr/share/man/man1
 file path=usr/bin/apptrace mode=0555
-file path=usr/lib/abi/$(ARCH64)/apptrace.so.1
+$(BUILD64)file path=usr/lib/abi/$(ARCH64)/apptrace.so.1
 file path=usr/lib/abi/apptrace.so.1
 file path=usr/share/man/man1/apptrace.1
 legacy pkg=SUNWcstl \
--- old/usr/src/pkg/manifests/developer-debug-mdb-module-module-fibre-channel.mf	2014-04-11 13:24:06.361415354 +0100
+++ new/usr/src/pkg/manifests/developer-debug-mdb-module-module-fibre-channel.mf	2014-04-11 13:24:06.369710804 +0100
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 set name=pkg.fmri \
@@ -34,10 +35,10 @@
 dir path=usr/lib
 dir path=usr/lib/mdb group=sys
 dir path=usr/lib/mdb/kvm group=sys
-dir path=usr/lib/mdb/kvm/$(ARCH64) group=sys
-file path=usr/lib/mdb/kvm/$(ARCH64)/fcip.so group=sys mode=0555
-file path=usr/lib/mdb/kvm/$(ARCH64)/fcp.so group=sys mode=0555
-file path=usr/lib/mdb/kvm/$(ARCH64)/fctl.so group=sys mode=0555
+$(BUILD64)dir path=usr/lib/mdb/kvm/$(ARCH64) group=sys
+$(BUILD64)file path=usr/lib/mdb/kvm/$(ARCH64)/fcip.so group=sys mode=0555
+$(BUILD64)file path=usr/lib/mdb/kvm/$(ARCH64)/fcp.so group=sys mode=0555
+$(BUILD64)file path=usr/lib/mdb/kvm/$(ARCH64)/fctl.so group=sys mode=0555
 $(i386_ONLY)file path=usr/lib/mdb/kvm/fcip.so group=sys mode=0555
 $(i386_ONLY)file path=usr/lib/mdb/kvm/fcp.so group=sys mode=0555
 $(i386_ONLY)file path=usr/lib/mdb/kvm/fctl.so group=sys mode=0555
--- old/usr/src/pkg/manifests/developer-debug-mdb-module-module-qlc.mf	2014-04-11 13:24:06.553474811 +0100
+++ new/usr/src/pkg/manifests/developer-debug-mdb-module-module-qlc.mf	2014-04-11 13:24:06.562373859 +0100
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 set name=pkg.fmri value=pkg:/developer/debug/mdb/module/module-qlc@$(PKGVERS)
@@ -34,8 +35,8 @@
 dir path=usr/lib
 dir path=usr/lib/mdb group=sys
 dir path=usr/lib/mdb/kvm group=sys
-dir path=usr/lib/mdb/kvm/$(ARCH64) group=sys
-file path=usr/lib/mdb/kvm/$(ARCH64)/qlc.so group=sys mode=0555
+$(BUILD64)dir path=usr/lib/mdb/kvm/$(ARCH64) group=sys
+$(BUILD64)file path=usr/lib/mdb/kvm/$(ARCH64)/qlc.so group=sys mode=0555
 $(i386_ONLY)file path=usr/lib/mdb/kvm/qlc.so group=sys mode=0555
 legacy pkg=SUNWqlcu \
     desc="Utilties associated with the Qlogic Fibre Channel Adapter" \
